#!/usr/local/bin/ruby
#
# file name: check_dbi.cgi
#
#   cgi for db table check
#   
#
#   0.00 2013-05-23 S.Yamane
#   0.10 2014-01-06 S.Yamane debugged flag=init
#
#
######################################################################
require 'tempfile'
require 'fileutils'
require 'rexml/document'
require 'time'
require 'cgi'
require '../lib/pharma_db_lib'


#
#  key1,key2....,xml_data,datetime のテーブルを作成する。
#  text の場合は、varchar(64)に固定する。
#  
#  flag=create table_name=test_table tabel_form="machine_no,varchardate,date"
#
#
def info_table(table_name)
  d_column = []
  d_column << table_name

  db_soft = PharmaDbLib.get_db_soft()
  case db_soft
  when /postgres/
    sql_cmd =<<-SQL 
      \\d #{table_name}
    SQL
    datas = PharmaDbLib.exec_sql(sql_cmd)

    for dds in datas
      column,type,modifiers = dds
      d_column << column
    end
  when /mysql/
    sql_cmd =<<-SQL 
      show columns from #{table_name};
    SQL
    datas = PharmaDbLib.exec_sql(sql_cmd)
    for dds in datas
      column,type,modifiers = dds
      d_column << column
    end

  end

  return d_column

end
#
def list_table( )

  table_names = []
  db_soft = PharmaDbLib.get_db_soft()
  case db_soft
  when /postgres/
    sql_cmd =<<-SQL 
      \\dt
    SQL
    datas = PharmaDbLib.exec_sql(sql_cmd)
    for dds in datas
      aa,table_name,table,owner = dds
      next if table_name == nil
      table_names << table_name
    end
  when /mysql/
    sql_cmd =<<-SQL 
      show tables;
    SQL
    datas = PharmaDbLib.exec_sql(sql_cmd)
    for dds in datas
      table_names << dds.shift
    end
  end
  return table_names

end
#
#
def check_table( table_name )
  sql_cmd =<<-SQL 
    \\d #{table_name}
  SQL
  datas = PharmaDbLib.exec_sql(sql_cmd)
end

def error_cgi
  print "Content-Type:text/html;charset=EUC\n\n"
  print "*** CGI Error List ***<br />"
  print "#{CGI.escapeHTML($!.inspect)}<br />"
  $@.each {|x| print CGI.escapeHTML(x), "<br />"}
end

#########################################################
#
# main
#
#  flag=create table_name=test_table table_form="machine_no,varchar;work_date,date"
#  flag=list
#
#########################################################

cgi = CGI.new

begin

  h_data = PharmaDbLib.init();
  db_soft = PharmaDbLib.get_db_soft()

  flag = cgi['flag']

  print cgi.header("content-type"=>"text/html","charset"=>"UTF-8")
  	print "db_soft =",db_soft,"<BR>"
  case flag
  when 'init'
	
    PharmaDbLib.list_param();
	##print "aaa\n"
    #h_data.each do |key, val|
    #  print key,": ",val,"<BR>"
    #end

  when 'dbname'
    if ( db_soft == "mysql" ) then
       sql_cmd =<<-SQL
	show databases;
       SQL
    else
       sql_cmd =<<-SQL
         \\c
       SQL

    end
    datas = PharmaDbLib.exec_sql(sql_cmd)
    for dds in datas 
	    print dds,"<BR>"
    end
  when 'tablename'
    if ( db_soft == "mysql" ) then
       sql_cmd =<<-SQL
         show tables;
       SQL
    else
       sql_cmd =<<-SQL
         \\dt
       SQL

    end
    datas = PharmaDbLib.exec_sql(sql_cmd)
    for dds in datas 
	    print dds,"<BR>"
    end

  else
    STDERR.print "ERROR! flag=[init,dbname,tablename]\n"
    exit
  end
rescue
  error_cgi
end


#
#
#
