#!/usr/local/bin/ruby
#
# file name: db_pharma-sc_cgi_v1.00.rb
#
#   cgi for access to postgresql database.
#
#   0.00 2013-03-25 s.yamane
#   1.00 2013-11-06 s.yamane added require 'kconv'
#				   xml_data.toutf8
#
#
require 'kconv'	# 2013-11-07
require 'cgi'
require 'rexml/document'
#
require '../lib/pharma_db_lib'
#require '../lib/pharma_postgres_lib'


  def check_table(table_name)
      
    case @db_soft
    when /postgres/
       # for postgres
       sql_cmd =<<-SQL
         SELECT relname FROM pg_class WHERE relkind = 'r' AND 
 	 relname = '#{table_name}'
       SQL

    when 'mysql'
       # for mysql
       sql_cmd =<<-SQL
         show tables like '#{table_name}'
       SQL
    end

    datas = exec_sql(sql_cmd)
    if ( datas.size == 0 ) then
 	  ##h_error["table_name"] = "#{table_name}テーブルがありません!!" 
          flag = false
    else
  	  flag = true
    end
  	return flag
  end

# <pharma-sc>
#  <machine database="key" >test-01</machine>
#  <data1>0.0001</data1>
# </pharma-sc>
#
def get_keys(xml_data)
  h_keys = Hash.new()

  
  doc = REXML::Document.new(xml_data)

  
  pharma = doc.root
  pharma.elements.each { |key|
    val = key.text()
	STDERR.print "get_keys: val=",val ,"\n"
    key_flag = key.attributes.get_attribute('database')
    next if key_flag == nil

    kk = key_flag.value.to_s
    if ( kk =~ /key/ ) then
      name = key.name.to_s
        STDERR.print "get_keys: key_falg=",key_flag,"\n"
      h_keys[name] = val
    end
  }

  return h_keys
end
#
#
# ??
#
def check_praim_key_on_table( table_name, h_key )

  flag = true
  d_err_column = []
  h_key.each do |key_column, val|
    c_flag = PharmaDbLib.check_column( table_name, key_column )
    if ( c_flag == false ) then
      flag = false
      d_err_column << key_column
    end
  end 

  p_column = d_err_column.join(",")
  
  return flag,p_column
end
#
#
#
def insert_data(table_name, h_key, xml_data)

  if ( h_key.size == 0 ) then
	  STDERR.print "insert data dose not key!!\n"
	  `echo  "insert data dose not key!!\n" > /tmp/insert_err_#{$$}`
    return
  end

  delete_sql = "delete from #{table_name} where 0=0\n" 

  h_key.each do |key,val|
    d_cmd = "and #{key} = '#{val}'\n"
    delete_sql += d_cmd
  end

  delete_sql = "#{delete_sql};\n"

  	 datas = PharmaDbLib.exec_sql(delete_sql)	# 2013-11-07

	   STDERR.print delete_sql

  #
  upto_date = Time.now().strftime("%Y-%m-%d %H:%M:%S")

  insert_sql = "insert into #{table_name}\n" 
  col_name = "("
  value   = "values("

  h_key.each do |key,val|
    col_name += "#{key},"
    value   += "'#{val}',"
  end

  col_name += "xml_data,"
  col_name += "upto_date)\n"

  value   += "'#{xml_data}',"
  value   += "'#{upto_date}');"

  insert_sql += col_name
  insert_sql += value

   STDERR.print insert_sql

   #sql_cmd = delete_sql + insert_sql
   sql_cmd = insert_sql
   
       #`echo #{sql_cmd} > /tmp/insert_#{$$}.sql`
	STDERR.print "\n ------------------------\n"
	STDERR.print "insert_data sql_cmd =",sql_cmd,"\n"
	STDERR.print " ------------------------\n"

   datas = PharmaDbLib.exec_sql(sql_cmd)

   return sql_cmd

end



#
#def select(h_key,xml_data)
#
#
#end

def debug_check_xml()

 table = "test_lot"
 xml_data = ""
 xml_data =<<-XMLEND
 <?xml version="1.0" encoding="UTF-8"?>
 <pharma-sc>
   <machine database="key">test-01</machine>
   <date database="key">2013/03/22</date>
   <data1>0.0001</data1>
   <data2>0.0001</data2>
 </pharma-sc>
 XMLEND
 return table,xml_data
end
#########################################################
#
# main
#
#
#########################################################

cgi = CGI.new

PharmaDbLib.init();

##table = cgi['table'][0]		# table name
##xml_data = cgi['xml_data'][0]	# xml data
table = cgi['table']		# table name
xml_data = cgi['xml_data']	# xml data

#for check
#table = "machine_data"
#xml_data = '<?xml version="1.0" encoding="UTF-8"?><pharma-sc><database>machine_data</database><product_type database="key">test_B</product_type><process database="key">test_Process_B</process><machine_no_1>test-02</machine_no_1><machine_name_1>yamane</machine_name_1><record_date_1>2013-11-11</record_date_1><remark_1>aaaa</remark_1></pharma-sc>'


#table,xml_data = debug_check_xml()
#
# 	print table,xml_data,"\n"

  STDERR.print "table=",table,"\n"
  STDERR.print "xml_data=",xml_data,"\n"
#
xml_data = xml_data.toutf8	# 2013-11-07
flag = true
err_msg = []
#
# プライマリーキーの取り出し。
h_key = get_keys(xml_data)

	STDERR.print "h_key=\n"
	STDERR.print h_key,"\n"
	STDERR.print "h_key=\n"

if( h_key.size == 0 ) then
  flag = false
  err_msg << "プライマリーキーがデータにセットされていません"
end
#
# table check
#t_flag = PharmaDbLib.check_table( table )
#if ( t_flag != true ) then
#  flag = false
#  err_msg << "#{table} が存在しません。"
#end

##p_flag,p_column = check_praim_key_on_table( table, h_key )
#if ( p_flag != true ) then
#  flag = false
#  err_msg << "#{table} に #{p_column}が存在しません。"
#end

if ( flag != true ) then
  print cgi.header("content-type"=>"text/plain","charset"=>"UTF-8")
  print "false\n"
  print err_msg.join("<BR>")
  exit
end

sql = insert_data(table, h_key, xml_data)

#
#  table delte_where columes datas
#
#
print cgi.header("content-type"=>"text/plain","charset"=>"UTF-8")
print "true\n"
#
print <<-END
#{xml_data}
END
