#!/usr/local/bin/ruby
#
# file name: list_data_database_cgi.rb
#
#   cgi for list data from database server.
#
#   0.00 2013-04-19 S.Yamane created
#   0.01 2013-05-21 S.Yamane lib/pharma_postgres_lib -> lib/pharma_db_lib
#
#
######################################################################
require 'tempfile'
require 'fileutils'
require 'cgi'
require 'rexml/document'
require 'time'
#require 'lib/pharma_postgres_lib'
require '../lib/pharma_db_lib'

#
#  
#
def select_data(table_name, d_where, get_xml_data )

  d_where_item = ["0=0"]
  d_where.each do |ww|

    # process=AAAA -> process='AAAA'
    ww1 = ww.gsub(/=\s*(.+)/,"='\\1'")

    d_where_item << ww1

  end

  where_item = d_where_item.join(" and ")

  sql_cmd =<<-SQL 
    select xml_data
    from #{table_name}
    where #{where_item}
    ; 
  SQL

  	STDERR.print "sql_cmd=\n", sql_cmd,"\n"

  #datas = PharmaPgLib.exec_sql(sql_cmd)
  datas = PharmaDbLib.exec_sql(sql_cmd)

  xml_data = datas[0].shift()
  
  	#STDERR.print "xml_data=\n", xml_data,"\n"

  # xml_data から <get_xml_data-?> の textデータの取り出し。
  doc =  REXML::Document.new(xml_data)

  	#STDERR.print "doc=",doc,"\n"

  pharma = doc.elements["//pharma-sc"]
  #pharma.elements.collect() { |data|
  reg = Regexp.new(get_xml_data)
  d_xml_data = []
  pharma.collect() { |data|
    STDERR.print "data=",data,"\n"
    STDERR.print "data.name=",data.name,"\n"
    STDERR.print "data.text=",data.text,"\n"
    if ( data.name.to_s =~ reg ) then
      d_xml_data << data.text
    end
    
    
  } 
  xml_data = d_xml_data.sort.join("\n")
  return xml_data
end
#
#########################################################
#
# main
#
#  table:machine_data,where1:product_type='LED-test',where2:process='LED-process-1',data:machine_no
#
#
#########################################################

cgi = CGI.new

#PharmaPgLib.init();
PharmaDbLib.init();

select_data = cgi['select_data']

STDERR.print select_data,"\n"
d_datas = select_data.split(",")
	

table_name = nil
d_where = []
get_xml_data = nil

h_datas = Hash.new()
for dds in d_datas

  key,val = dds.split(/:/)
  case key
  when "table"
	  table_name = val
  when /^where/
	  d_where << val
  when "data"
	  get_xml_data = val
  end
end

#

datas = select_data(table_name, d_where, get_xml_data )

#
#
#

print cgi.header("content-type"=>"text/html","charset"=>"UTF-8")
print datas,"\n"
#
