#!/usr/local/bin/ruby
#
# file name: usr_login.cgi
#
#   cgi for WebPmSheet usr login table.
#    
#   
#
#   1.00 2013-09-26 S.Yamane created
#   1.10 2013-10-10 S.Yamane added create_uid,modify_uid,delete_uid
#   1.20 2013-10-22 S.Yamane ":" -> "/t"
#
#
######################################################################
require 'tempfile'
require 'fileutils'
require 'cgi'
require 'cgi/session'
require 'rexml/document'
require 'time'
require '../lib/pharma_db_lib'

Login_table = 'login'

# not useed
#
#  database name: login
#    for SQL injection.
#
def double_escape(str)
  str = str.gsub(/['"\\]/) {|ch| ch + ch }
  return str
end
#
#
def check_login(cgi, uid,password )

  flag = false
  uname = nil

  #change_db_cmd = change_db()
  
  change_db_cmd = ""

  uid = double_escape(uid)
  pasword = double_escape(password)

  sql_cmd =<<-SQL 
    select uname,perm_level
    from #{Login_table}
    where uid = '#{uid}'
    and password = '#{password}'
    ;
  SQL

  sql_cmd = change_db_cmd + sql_cmd
  datas = PharmaDbLib.exec_sql(sql_cmd)

  uname,perm_level = datas[0]
  uname.strip!() if uname != nil

  # check uid and password
  #
  if ( uname == nil || uname == "") then
    flag = false
    msg = "uid または、password が異なります。"
    return flag,msg
  end

  # check exiration_date
  #
  
  flag = true
  msg = "#{uname} 様 認証しました。"
  return flag,msg,uname,perm_level

end
#
#
def list_login(perm_level) 

  flag = false
  change_db_cmd = ""

  if ( perm_level != nil )
    perm_level = double_escape(perm_level)
    where = "where perm_level = '#{perm_level}'"
  end

  sql_cmd =<<-SQL 
    
    select
    uid, uname, password, perm_level, uptdate, remark
    from #{Login_table}
    #{where}
    ;
  SQL

  sql_cmd = change_db_cmd + sql_cmd
  datas = PharmaDbLib.exec_sql(sql_cmd)

  # check uid and password
  
  flag = true
  return datas

end
#
#
def create_login(uid, uname, password, perm_level, remark) 
  flag = false

  change_db_cmd = ""

  uid = double_escape(uid)
  uname = double_escape(uname)
  password = double_escape(password)
  perm_level = double_escape(perm_level)
  remark = double_escape(remark)

  if ( uid == nil || uid.size == 0 ) then
    msg = "uid error!!"
    return flag,msg
  end

  if ( uname == nil || uname.size == 0 ) then
    msg = "uname error!!"
    return flag,msg
  end

  if ( password == nil || password.size == 0 ) then
    msg = "password error!!"
    return flag,msg
  end

  if ( perm_level == nil || perm_level.size == 0 ) then
     perm_level = 9
  end

  sql_cmd =<<-SQL 
    
    insert into #{Login_table}
    (uid, uname, password, perm_level, remark )
    value
    ("#{uid}", "#{uname}", "#{password}", "#{perm_level}", "#{remark}" )
    ;
  SQL

  sql_cmd = change_db_cmd + sql_cmd
  datas = PharmaDbLib.exec_sql(sql_cmd)

  # check uid and password
  
  flag = true
  return flag,uname,perm_level,remark

end
#
def modify_login(uid, uname, password, perm_level, remark) 
  flag = false

  change_db_cmd = ""

  uid = double_escape(uid)
  uname = double_escape(uname)
  pasword = double_escape(password)
  perm_level = double_escape(perm_level)
  remark = double_escape(remark)

  sql_cmd =<<-SQL 
    
    update #{Login_table}
    set
    uname = '#{uname}', 
    password = '#{password}', 
    perm_level = '#{perm_level}', 
    remark = '#{remark}' 

    where uid = '#{uid}'
    ;
  SQL

  sql_cmd = change_db_cmd + sql_cmd
  datas = PharmaDbLib.exec_sql(sql_cmd)

  # check uid and password
  
  flag = true
  return flag,uid,uname,perm_level,remark

end
#
#
def delete_login(uid)
  flag = false

  change_db_cmd = ""

  uid = double_escape(uid)

  sql_cmd =<<-SQL 
    
    delete from #{Login_table}
    where
     uid = "#{uid}"
    ;
  SQL

  sql_cmd = change_db_cmd + sql_cmd
  datas = PharmaDbLib.exec_sql(sql_cmd)

  # check uid and password
  
  flag = true
  return flag,uid


end
#
#
#
#
#########################################################
#
# main
#
#  uid=13001 password=yamane
#
#  flag=list
#  flag=insert uid=13099 uname=test_user password=test perm_level=0 remark=test
#  flag=modify uid=13099 uname=test_user_aa password=test perm_level=0 remark=test
#  flag=delete uid=13099
#
#########################################################


PharmaDbLib.init();

cgi = CGI.new

flag = cgi['flag']

uid        = cgi['uid']
uname      = cgi['uname']
password   = cgi['password']

perm_level = cgi['perm_level']
remark     = cgi['remark']

  print cgi.header("content-type"=>"text/html","charset"=>"UTF-8")

case flag
when nil

  flag,msg,uname,perm_level = check_login(cgi, uid, password)
  ##print flag,"",msg,":",uname,":",perm_level,"\n"
  print flag,"\t",msg,"\t",uname,"\t",perm_level,"\n"
when "list"
  list_perm_level = nil;
  datas = list_login(list_perm_level) 
  for dds in datas  
    ##print dds.join(":"),"\n"
    print dds.join("\t"),"\n"
  end

when "create"
  flag,msg = create_login(uid,uname, password, perm_level, remark) 
  ##print flag,":",uname,":",perm_level,"\n"
  ##print flag,"\t",uname,"\t",perm_level,"\n"
  print flag,"\t",msg,"\n"
when "modify"
  flag,uid,uname = modify_login(uid,uname, password, perm_level, remark) 
  ##print flag,":",uid,"\n"
  print flag,"\t",uid,"\n"
when "delete"
  flag = delete_login(uid)
  ##print flag,":",uid,"\n"
  print flag,"\t",uid,"\n"

end
#
#
#
